package uoc.javier.allpay;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.text.SpannableString;
import android.text.style.RelativeSizeSpan;
import android.view.View;
import android.widget.Button;
import android.widget.Toast;

public class GroupActivity extends AppCompatActivity implements View.OnClickListener{
    private static final String TAG = "HC:GroupActivity";

    // Views
    private Button buttonCreate;
    private Button buttonEdit;
    private Button buttonSwap;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_group);

        // Set views
        buttonCreate = (Button) findViewById(R.id.btn_add);
        buttonEdit = (Button) findViewById(R.id.btn_edit);
        buttonSwap = (Button) findViewById(R.id.btn_swap);

        // Set listeners
        buttonCreate.setOnClickListener(this);
        buttonEdit.setOnClickListener(this);
        buttonSwap.setOnClickListener(this);
    }

    @Override
    public void onClick(View v) {
        if (v == buttonCreate) {
            showToast(getResources().getString(R.string.new_group));
            goTabbedActivity();
        }else if (v == buttonEdit){
            showToast(getResources().getString(R.string.edit_group));
            goTabbedActivity();
        }else if (v == buttonSwap){
            showToast(getResources().getString(R.string.swap_group));
            goTabbedActivity();
        }
    }

    public void goTabbedActivity(){
        // Go to the main fragment of the TabbetActivity and clean all the fields
        Intent intent = new Intent(this, TabbedActivity.class);
        startActivity(intent);
    }

    public void showToast(String str){
        // Configuration size of text
        SpannableString ss =  new SpannableString(str);
        ss.setSpan(new RelativeSizeSpan(1.5f), 0, ss.length(), 0);

        // Show the message
        Toast.makeText(this, ss, Toast.LENGTH_LONG).show();
    }
}
