package uoc.javier.allpay;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.net.Uri;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.v4.app.Fragment;
import android.text.SpannableString;
import android.text.method.ScrollingMovementMethod;
import android.text.style.RelativeSizeSpan;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.gms.tasks.OnFailureListener;
import com.google.android.gms.tasks.OnSuccessListener;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.ValueEventListener;
import com.thomashaertel.widget.MultiSpinner;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import uoc.javier.allpay.model.Item;


/**
 * A simple {@link Fragment} subclass.
 * Activities that contain this fragment must implement the
 * Use the {@link NewItemFragment#newInstance} factory method to
 * create an instance of this fragment.
 */
public class NewItemFragment extends Fragment implements View.OnClickListener{
    private static final String TAG = "TFM:NewItemFragment";

    // TODO: Rename parameter arguments, choose names that match
    // the fragment initialization parameters, e.g. ARG_ITEM_NUMBER
    private static final String ARG_PARAM1 = "param1";
    private static final String ARG_PARAM2 = "param2";

    // TODO: Rename and change types of parameters
    private String mParam1;
    private String mParam2;

    // UI references.
    private EditText etDescription;
    private EditText etPrice;
    private Button buttonAdd;
    private Button buttonReturn;

    private Spinner spnType;

    private MultiSpinner mspnReceivers;
    private ArrayAdapter<String> adapterReceivers;
    private TextView tvReceivers;

    private MultiSpinner mspnPayers;
    private ArrayAdapter<String> adapterPayers;
    private TextView tvPayers;

    // Firebase
    private Map<String, Boolean> username_payers = new HashMap<>();
    private Map<String, Boolean> username_receivers = new HashMap<>();
    private DatabaseReference mDatabase;
    private DatabaseReference databaseItemsHistorical;

    public NewItemFragment() {
        // Required empty public constructor
    }

    /**
     * Use this factory method to create a new instance of
     * this fragment using the provided parameters.
     *
     * @param param1 Parameter 1.
     * @param param2 Parameter 2.
     * @return A new instance of fragment NewItemFragment.
     */
    // TODO: Rename and change types and number of parameters
    public static NewItemFragment newInstance(String param1, String param2) {
        NewItemFragment fragment = new NewItemFragment();
        Bundle args = new Bundle();
        args.putString(ARG_PARAM1, param1);
        args.putString(ARG_PARAM2, param2);
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments() != null) {
            mParam1 = getArguments().getString(ARG_PARAM1);
            mParam2 = getArguments().getString(ARG_PARAM2);
        }
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        return inflater.inflate(R.layout.fragment_new_item, container, false);
    }

    @Override
    public void onViewCreated(final View view, Bundle savedInstanceState) {
        Activity activity = getActivity();

        etDescription = (EditText) view.findViewById(R.id.et_description);
        etPrice = (EditText) view.findViewById(R.id.et_price);

        buttonAdd = (Button) view.findViewById(R.id.btn_add);
        buttonReturn = (Button) view.findViewById(R.id.btn_return);

        // Spinner type
        spnType = (Spinner) view.findViewById(R.id.spn_type);
        // Create an ArrayAdapter using the string array and the developed spinner layout
        ArrayAdapter<CharSequence> adapter = ArrayAdapter.createFromResource(activity, R.array.product_types, R.layout.my_spinner);
        // Specify the layout to use when the list of choices appears
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        // Apply the adapter to the spinner
        spnType.setAdapter(adapter);

        // MultiSpinner payers
        mspnPayers = (MultiSpinner) view.findViewById(R.id.mspn_payers);
        adapterPayers = new ArrayAdapter<String>(activity, R.layout.my_spinner);
        mspnPayers.setVisibility(View.GONE);
        tvPayers = (TextView) view.findViewById(R.id.tv_payers);
        tvPayers.setMovementMethod(new ScrollingMovementMethod());

        // MultiSpinner receivers
        mspnReceivers = (MultiSpinner) view.findViewById(R.id.mspn_receivers);
        adapterReceivers = new ArrayAdapter<String>(activity, R.layout.my_spinner);
        mspnReceivers.setVisibility(View.GONE);
        tvReceivers = (TextView) view.findViewById(R.id.tv_receivers);
        tvReceivers.setMovementMethod(new ScrollingMovementMethod());

        // Download users from Firebase
        DatabaseReference databaseUsers;
        databaseUsers = FirebaseDatabase.getInstance().getReference("users");

        databaseUsers.addValueEventListener(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot) {
                for(DataSnapshot user : dataSnapshot.getChildren()){
                    adapterPayers.add(user.getKey());
                    adapterReceivers.add(user.getKey());
                }
            }

            @Override
            public void onCancelled(DatabaseError error) {
                // Failed to read value
                Log.d(TAG, "Failed to read value", error.toException());
            }
        });

        adapterPayers.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        mspnPayers.setAdapter(adapterPayers, false, onSelectedListenerPayers);

        adapterReceivers.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        mspnReceivers.setAdapter(adapterReceivers, false, onSelectedListenerReceivers);

        mDatabase = FirebaseDatabase.getInstance().getReference("items");
        databaseItemsHistorical = FirebaseDatabase.getInstance().getReference("items_historical");

        // Set listeners
        buttonAdd.setOnClickListener(this);
        buttonReturn.setOnClickListener(this);
        tvReceivers.setOnClickListener(this);
        tvPayers.setOnClickListener(this);
    }

    private MultiSpinner.MultiSpinnerListener onSelectedListenerPayers = new MultiSpinner.MultiSpinnerListener() {
        public void onItemsSelected(boolean[] selected) {
            StringBuilder builder = new StringBuilder();

            // New username_payers
            username_payers = new HashMap<>();

            for (int i = 0; i < selected.length; i++) {
                if (selected[i]) {
                    builder.append(adapterPayers.getItem(i)).append(" ; ");
                    username_payers.put(adapterPayers.getItem(i), true);
                }
            }
            tvPayers.setText(builder.toString());
            //Toast.makeText(getActivity(), builder.toString(), Toast.LENGTH_SHORT).show();
        }
    };

    private MultiSpinner.MultiSpinnerListener onSelectedListenerReceivers = new MultiSpinner.MultiSpinnerListener() {
        public void onItemsSelected(boolean[] selected) {
            StringBuilder builder = new StringBuilder();

            // New username_receivers
            username_receivers = new HashMap<>();

            for (int i = 0; i < selected.length; i++) {
                if (selected[i]) {
                    builder.append(adapterReceivers.getItem(i)).append(" ; ");
                    username_receivers.put(adapterPayers.getItem(i), true);
                }
            }
            tvReceivers.setText(builder.toString());
            //Toast.makeText(getActivity(), builder.toString(), Toast.LENGTH_SHORT).show();
        }
    };

    public void onClick(View v) {
        if (v == buttonAdd){
            // Clean error message and icon from TextViews
            tvPayers.setError(null);
            tvReceivers.setError(null);

            // Check that each requiered field is filled
            if(!checkRequeriedFields(new EditText[]{etDescription, etPrice})){
                showToast(getResources().getString(R.string.complete_fields));
            }

            // Check that at least one user is the payer and one user is the receiver
            else if(username_payers.isEmpty()){
                tvPayers.setError(getResources().getString(R.string.complete_fields));
                showToast(getResources().getString(R.string.complete_fields));
            }

            else if (username_receivers.isEmpty()){
                tvReceivers.setError(getResources().getString(R.string.complete_fields));
                showToast(getResources().getString(R.string.complete_fields));
            }

            else{
                // Create new item
                Item add_item = new Item(etDescription.getText().toString(),
                        spnType.getSelectedItem().toString(),
                        etPrice.getText().toString(),
                        null, null);


                // Obtain the uid of the new created item
                String item_uid = mDatabase.push().getKey();

                // Create item
                mDatabase.child(item_uid).setValue(add_item)
                        .addOnSuccessListener(new OnSuccessListener<Void>() {
                            @Override
                            public void onSuccess(Void aVoid) {
                                //Log.d(TAG, "new item added");
                            }
                        })
                        .addOnFailureListener(new OnFailureListener() {
                            @Override
                            public void onFailure(@NonNull Exception e) {
                                showToast(getResources().getString(R.string.add_item_wrong));
                            }
                        });

                // Add the username_payers and username_receivers components to the new item
                mDatabase.child(item_uid).child("payers_users").setValue(username_payers)
                        .addOnSuccessListener(new OnSuccessListener<Void>() {
                            @Override
                            public void onSuccess(Void aVoid) {
                                //Log.d(TAG, "payers_users added");
                            }
                        })
                        .addOnFailureListener(new OnFailureListener() {
                            @Override
                            public void onFailure(@NonNull Exception e) {
                                showToast(getResources().getString(R.string.add_item_wrong));
                            }
                        });

                mDatabase.child(item_uid).child("receivers_users").setValue(username_receivers)
                        .addOnSuccessListener(new OnSuccessListener<Void>() {
                            @Override
                            public void onSuccess(Void aVoid) {
                                //Log.d(TAG, "receivers_users added");
                                showToast(getResources().getString(R.string.add_item_right));
                                // Go to the main fragment of the TabbetActivity and clean all the fields
                                goTabbedActivity();
                            }
                        })
                        .addOnFailureListener(new OnFailureListener() {
                            @Override
                            public void onFailure(@NonNull Exception e) {
                                showToast(getResources().getString(R.string.add_item_wrong));
                            }
                        });

                // Create the same item in the item_historical database with the same item_uid
                databaseItemsHistorical.child(item_uid).setValue(add_item)
                        .addOnSuccessListener(new OnSuccessListener<Void>() {
                            @Override
                            public void onSuccess(Void aVoid) {
                                //Log.d(TAG, "new item added");
                            }
                        })
                        .addOnFailureListener(new OnFailureListener() {
                            @Override
                            public void onFailure(@NonNull Exception e) {
                                showToast(getResources().getString(R.string.add_item_wrong));
                            }
                        });

                // Add the username_payers and username_receivers components to the new item
                databaseItemsHistorical.child(item_uid).child("payers_users").setValue(username_payers)
                        .addOnSuccessListener(new OnSuccessListener<Void>() {
                            @Override
                            public void onSuccess(Void aVoid) {
                                //Log.d(TAG, "payers_users added");
                            }
                        })
                        .addOnFailureListener(new OnFailureListener() {
                            @Override
                            public void onFailure(@NonNull Exception e) {
                                showToast(getResources().getString(R.string.add_item_wrong));
                            }
                        });

                databaseItemsHistorical.child(item_uid).child("receivers_users").setValue(username_receivers)
                        .addOnSuccessListener(new OnSuccessListener<Void>() {
                            @Override
                            public void onSuccess(Void aVoid) {
                                //Log.d(TAG, "receivers_users added");
                                showToast(getResources().getString(R.string.add_item_right));
                                // Go to the main fragment of the TabbetActivity and clean all the fields
                                goTabbedActivity();
                            }
                        })
                        .addOnFailureListener(new OnFailureListener() {
                            @Override
                            public void onFailure(@NonNull Exception e) {
                                showToast(getResources().getString(R.string.add_item_wrong));
                            }
                        });
            }
        }

        else if(v == buttonReturn){
            goTabbedActivity();
        }

        else if(v == tvReceivers){
            mspnReceivers.performClick();
        }

        else if(v == tvPayers){
            mspnPayers.performClick();
        }
    }

    public void goTabbedActivity(){
        // Go to the main fragment of the TabbetActivity and clean all the fields
        Intent intent = new Intent(getContext(), TabbedActivity.class);
        startActivity(intent);
    }

    public boolean checkRequeriedFields(EditText[] fields){
        EditText currentField;
        for(int i=0; i<fields.length; i++){
            currentField = fields[i];
            if(currentField.getText().toString().length() <=0){
                currentField.setError(getResources().getString(R.string.complete_fields));
                return false;
            }
        }
        return true;
    }

    public void showToast(String str){
        // Configuration size of text
        SpannableString ss =  new SpannableString(str);
        ss.setSpan(new RelativeSizeSpan(1.5f), 0, ss.length(), 0);

        // Show the message
        Toast.makeText(getActivity(), ss, Toast.LENGTH_LONG).show();
    }


}
