package uoc.javier.allpay.utils;

import android.support.annotation.Nullable;
import android.support.v7.util.DiffUtil;

import java.util.List;

import uoc.javier.allpay.model.Goal;

public class GoalDiffCallback extends DiffUtil.Callback  {

    List<Goal> oldFav;
    List<Goal> newFav;

    public GoalDiffCallback(List<Goal> newFav, List<Goal> oldFav) {
        this.newFav = newFav;
        this.oldFav = oldFav;
    }

    @Override
    public int getOldListSize() {
        return oldFav.size();
    }

    @Override
    public int getNewListSize() {
        return newFav.size();
    }

    @Override
    public boolean areItemsTheSame(int oldItemPosition, int newItemPosition) {
        Goal oldObject = oldFav.get(oldItemPosition);
        Goal newObject = newFav.get(newItemPosition);
        boolean itemsSame = false;
        if (oldObject.getSubject().equalsIgnoreCase(newObject.getSubject())) {
            itemsSame = true;
        }
        return itemsSame;
    }

    @Override
    public boolean areContentsTheSame(int oldItemPosition, int newItemPosition) {
        return oldFav.get(oldItemPosition).equals(newFav.get(newItemPosition));
    }

    @Nullable
    @Override
    public Object getChangePayload(int oldItemPosition, int newItemPosition) {
        //no se utiliza payload, por lo que no se utiliza el método
        return super.getChangePayload(oldItemPosition, newItemPosition);
    }
}
