package uoc.javier.allpay.utils;

import android.support.annotation.Nullable;
import android.support.v7.util.DiffUtil;

import java.util.List;

import uoc.javier.allpay.model.Item;

public class ItemDiffCallback extends DiffUtil.Callback{
    List<Item> oldFav;
    List<Item> newFav;

    public ItemDiffCallback(List<Item> newFav, List<Item> oldFav) {
        this.newFav = newFav;
        this.oldFav = oldFav;
    }

    @Override
    public int getOldListSize() {
        return oldFav.size();
    }

    @Override
    public int getNewListSize() {
        return newFav.size();
    }

    @Override
    public boolean areItemsTheSame(int oldItemPosition, int newItemPosition) {
        Item oldObject = oldFav.get(oldItemPosition);
        Item newObject = newFav.get(newItemPosition);
        boolean itemsSame = false;
        if (oldObject.getDescription().equalsIgnoreCase(newObject.getDescription())) {
            itemsSame = true;
        }
        return itemsSame;
    }

    @Override
    public boolean areContentsTheSame(int oldItemPosition, int newItemPosition) {
        return oldFav.get(oldItemPosition).equals(newFav.get(newItemPosition));
    }

    @Nullable
    @Override
    public Object getChangePayload(int oldItemPosition, int newItemPosition) {
        //no se utiliza payload, por lo que no se utiliza el método
        return super.getChangePayload(oldItemPosition, newItemPosition);
    }
}
