package uoc.javier.allpay.utils;

import android.support.annotation.Nullable;
import android.support.v7.util.DiffUtil;

import java.util.List;

import uoc.javier.allpay.model.Payment;

public class PaymentDiffCallback extends DiffUtil.Callback{
    List<Payment> oldFav;
    List<Payment> newFav;

    public PaymentDiffCallback(List<Payment> newFav, List<Payment> oldFav) {
        this.newFav = newFav;
        this.oldFav = oldFav;
    }

    @Override
    public int getOldListSize() {
        return oldFav.size();
    }

    @Override
    public int getNewListSize() {
        return newFav.size();
    }

    @Override
    public boolean areItemsTheSame(int oldItemPosition, int newItemPosition) {
        Payment oldObject = oldFav.get(oldItemPosition);
        Payment newObject = newFav.get(newItemPosition);
        boolean itemsSame = false;
        if (oldObject.getUsername().equalsIgnoreCase(newObject.getUsername())) {
            itemsSame = true;
        }
        return itemsSame;
    }

    @Override
    public boolean areContentsTheSame(int oldItemPosition, int newItemPosition) {
        return oldFav.get(oldItemPosition).equals(newFav.get(newItemPosition));
    }

    @Nullable
    @Override
    public Object getChangePayload(int oldItemPosition, int newItemPosition) {
        //no se utiliza payload, por lo que no se utiliza el método
        return super.getChangePayload(oldItemPosition, newItemPosition);
    }
}
